%{

/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


#ifndef __rename_H
#include "rename.h"
#endif
  
#ifndef __dbserver_HXX
#include "dbserver.hxx"
#endif

#ifndef __virtualdbserver_HXX
#include "virtualdbserver.hxx"
#endif

#ifndef __string_H
#define __string_H
#include <string.h>
#endif

#ifndef __stdlib_H
#define __stdlib_H
#include <stdlib.h>
#endif

#ifndef __iostream_H
#define __iostream_H
#include <iostream.h>
#endif

#ifndef __list_HXX
#include "list.hxx"
#endif

#ifndef __volume_HXX
#include "volume.hxx"
#endif

#ifndef __dbvue_HXX
#include "dbvue.hxx"
#endif

#ifndef __var_H
#include "var.h"
#endif

#include "dbconfig.h"

int dbconf_linecount = 0 ;

extern "C" {
  int yywrap() ;
  int yyparse() ;
}

#if defined(__alpha__) || (defined(__sun__) && !defined(__svr4__))
int yylex() ;
#endif

#if defined(__alpha__) || (defined(__sun__) && !defined(__svr4__))
int yyoutput(int c) ; 
#else
extern "C" { int yyoutput(int c) ; }
#endif



%}

%union  {
  int  integer ;
  char text[SIZEOF_TOKEN];
  ListPtr<Volume>* vol_list ;
  Volume* vol ;
} ;

%token VOLUME FILETOK LOG SERVER ID
%token <text> IDENT FILENAME
%token <integer> INT

%type <vol_list> volume_list
%type <vol> volume
%type <text> log

%start all

%%

all: server_list ;


server_list :
         server
         | server server_list ;


server :
         SERVER IDENT '{' log volume_list '}'
           {
	     if ((YOO_DBServer != NULL) &&
		 ( (strcmp(YOO_DBServer->name(), MONOUSER) == 0) ||
		   (strcmp(YOO_DBServer->name(), $2) == 0) ) ) {
	       YOO_DBServer->setLog($4) ;
	       YOO_DBServer->setVolume($5) ;
	     }
             if (YOO_VirtualServer != NULL) {
	       YOO_VirtualServer->createVue($2, $5) ;
             }
           }


log :
         LOG FILENAME ';'
           {
	     strcpy($$, $2) ;
	   }


volume_list :
         volume
           {
	     $$ = new ListPtr<Volume> ;
	     $$->insert($1, 0) ;
	   }
	 | volume volume_list 
           {
	     $$ = $2 ;
	     $$->insert($1, 0) ;
	   }


volume :
         VOLUME IDENT '{' ID INT ';' FILETOK FILENAME ';' '}'
           {
	     $$ = new Volume($8, $5) ;
	   }

%%


extern "C"
{
void yoo_config() {
  SYSCALLP(yyin = fopen(YOO_VOL_FILE, "r")) ;
  yyparse() ;
  SYSCALLI(fclose(yyin)) ;
}

#ifdef hpux
}
void yyerror(char* s) {
#else
int yyerror(char* s) {
#endif
  
  cout << "Volume parse error line : " << dbconf_linecount << endl ;
  yoo_exit(1) ;
  return 1 ;
}

#ifndef hpux
}
#endif

